Index: uspace/lib/block/doc/doxygroups.h
===================================================================
--- uspace/lib/block/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/block/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,4 @@
+/** @addtogroup libblock libblock
+ * @ingroup libs
+ * @brief Library for working with block devices
+ */
Index: uspace/lib/c/arch/abs32le/include/libarch/faddr.h
===================================================================
--- uspace/lib/c/arch/abs32le/include/libarch/faddr.h	(revision aab85d90491f3f45f389ff54ed1149c7ec03a816)
+++ uspace/lib/c/arch/abs32le/include/libarch/faddr.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libabs32le
+/** @addtogroup libcabs32le
  * @{
  */
Index: uspace/lib/c/arch/ppc32/include/libarch/config.h
===================================================================
--- uspace/lib/c/arch/ppc32/include/libarch/config.h	(revision aab85d90491f3f45f389ff54ed1149c7ec03a816)
+++ uspace/lib/c/arch/ppc32/include/libarch/config.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libppc32
+/** @addtogroup libcppc32
  * @{
  */
Index: uspace/lib/c/arch/riscv64/include/libarch/faddr.h
===================================================================
--- uspace/lib/c/arch/riscv64/include/libarch/faddr.h	(revision aab85d90491f3f45f389ff54ed1149c7ec03a816)
+++ uspace/lib/c/arch/riscv64/include/libarch/faddr.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libriscv64
+/** @addtogroup libcriscv64
  * @{
  */
Index: uspace/lib/c/doc/doxygroups.h
===================================================================
--- uspace/lib/c/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/c/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,51 @@
+/**
+ * @addtogroup libc libc
+ * @brief HelenOS C library
+ * @ingroup libs
+ */
+
+/**
+ * @addtogroup libcabs32le abs32le
+ * @ingroup libc
+ */
+
+/**
+ * @addtogroup libcamd64 amd64
+ * @ingroup libc
+ */
+
+/**
+ * @addtogroup libcarm32 arm32
+ * @ingroup libc
+ */
+
+/**
+ * @addtogroup libcia32 ia32
+ * @ingroup libc
+ */
+
+/**
+ * @addtogroup libcia64 ia64
+ * @ingroup libc
+ */
+
+/**
+ * @addtogroup libcmips32 mips32
+ * @ingroup libc
+ */
+
+/**
+ * @addtogroup libcppc32 ppc32
+ * @ingroup libc
+ */
+
+/**
+ * @addtogroup libcriscv64 riscv64
+ * @ingroup libc
+ */
+
+/**
+ * @addtogroup libcsparc64 sparc64
+ * @ingroup libc
+ */
+
Index: uspace/lib/c/generic/libc.c
===================================================================
--- uspace/lib/c/generic/libc.c	(revision aab85d90491f3f45f389ff54ed1149c7ec03a816)
+++ uspace/lib/c/generic/libc.c	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -27,12 +27,5 @@
  */
 
-/** @addtogroup lc Libc
- * @brief HelenOS C library
- * @{
- * @}
- */
-
-/** @addtogroup libc generic
- * @ingroup lc
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/clui/doc/doxygroups.h
===================================================================
--- uspace/lib/clui/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/clui/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup libclui libclui
+ * @ingroup libs
+ */
Index: uspace/lib/clui/tinput.c
===================================================================
--- uspace/lib/clui/tinput.c	(revision aab85d90491f3f45f389ff54ed1149c7ec03a816)
+++ uspace/lib/clui/tinput.c	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -25,4 +25,8 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libclui
+ * @{
  */
 
@@ -1053,2 +1057,6 @@
 	}
 }
+
+/**
+ * @}
+ */
Index: uspace/lib/dltest/dltest.c
===================================================================
--- uspace/lib/dltest/dltest.c	(revision aab85d90491f3f45f389ff54ed1149c7ec03a816)
+++ uspace/lib/dltest/dltest.c	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -28,5 +28,4 @@
 
 /** @addtogroup libdltest
- * @brief Dynamic linking test library
  * @{
  */
Index: uspace/lib/dltest/doc/doxygroups.h
===================================================================
--- uspace/lib/dltest/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/dltest/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,4 @@
+/** @addtogroup libdltest libdltest
+ * @brief Dynamic linking test library
+ * @ingroup libs
+ */
Index: uspace/lib/dltest/libdltest.h
===================================================================
--- uspace/lib/dltest/libdltest.h	(revision aab85d90491f3f45f389ff54ed1149c7ec03a816)
+++ uspace/lib/dltest/libdltest.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -28,5 +28,4 @@
 
 /** @addtogroup libdltest
- * @brief Dynamic linking test library
  * @{
  */
Index: uspace/lib/drv/doc/doxygroups.h
===================================================================
--- uspace/lib/drv/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/drv/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,4 @@
+/** @addtogroup libdrv libdrv
+ * @ingroup libs
+ * @brief Generic device driver support
+ */
Index: uspace/lib/drv/generic/dev_iface.c
===================================================================
--- uspace/lib/drv/generic/dev_iface.c	(revision aab85d90491f3f45f389ff54ed1149c7ec03a816)
+++ uspace/lib/drv/generic/dev_iface.c	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -28,6 +28,5 @@
 
 /**
- * @defgroup libdrv generic device driver support.
- * @brief HelenOS generic device driver support.
+ * @addtogroup libdrv
  * @{
  */
Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision aab85d90491f3f45f389ff54ed1149c7ec03a816)
+++ uspace/lib/drv/generic/driver.c	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -29,6 +29,5 @@
 
 /**
- * @defgroup libdrv generic device driver support.
- * @brief HelenOS generic device driver support.
+ * @addtogroup libdrv
  * @{
  */
Index: uspace/lib/drv/generic/interrupt.c
===================================================================
--- uspace/lib/drv/generic/interrupt.c	(revision aab85d90491f3f45f389ff54ed1149c7ec03a816)
+++ uspace/lib/drv/generic/interrupt.c	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -28,6 +28,5 @@
 
 /**
- * @defgroup libdrv generic device driver support.
- * @brief HelenOS generic device driver support.
+ * @addtogroup libdrv
  * @{
  */
Index: uspace/lib/ext4/doc/doxygroups.h
===================================================================
--- uspace/lib/ext4/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/ext4/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,4 @@
+/** @addtogroup libext4 libext4
+ * @ingroup libs
+ * @brief Library for implementing the ext4 file system and utilities
+ */
Index: uspace/lib/fdisk/doc/doxygroups.h
===================================================================
--- uspace/lib/fdisk/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/fdisk/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup libfdisk libfdisk
+ * @ingroup libs
+ */
Index: uspace/lib/fs/doc/doxygroups.h
===================================================================
--- uspace/lib/fs/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/fs/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,4 @@
+/** @addtogroup libfs libfs
+ * @brief Library for implementing file systems
+ * @ingroup libs
+ */
Index: uspace/lib/http/doc/doxygroups.h
===================================================================
--- uspace/lib/http/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/http/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup http libhttp
+ * @ingroup libs
+ */
Index: uspace/lib/ieee80211/doc/doxygroups.h
===================================================================
--- uspace/lib/ieee80211/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/ieee80211/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup libieee80211 libieee80211
+ * @ingroup libs
+ */
Index: uspace/lib/label/doc/doxygroups.h
===================================================================
--- uspace/lib/label/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/label/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup liblabel liblabel
+ * @ingroup libs
+ */
Index: uspace/lib/math/doc/doxygroups.h
===================================================================
--- uspace/lib/math/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/math/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,56 @@
+/**
+ * @addtogroup libmath libmath
+ * @ingroup libs
+ */
+
+/**
+ * @addtogroup libmathabs32le abs32le
+ * @ingroup libmath
+ */
+
+/**
+ * @addtogroup libmathamd64 amd64
+ * @ingroup libmath
+ */
+
+/**
+ * @addtogroup libmatharm32 arm32
+ * @ingroup libmath
+ */
+
+/**
+ * @addtogroup libmathia32 ia32
+ * @ingroup libmath
+ */
+
+/**
+ * @addtogroup libmathia64 ia64
+ * @ingroup libmath
+ */
+
+/**
+ * @addtogroup libmathmips32 mips32
+ * @ingroup libmath
+ */
+
+/**
+ * @addtogroup libmathmips32eb mips32eb
+ * @ingroup libmath
+ */
+
+
+/**
+ * @addtogroup libmathppc32 ppc32
+ * @ingroup libmath
+ */
+
+/**
+ * @addtogroup libmathriscv64 riscv64
+ * @ingroup libmath
+ */
+
+/**
+ * @addtogroup libmathsparc64 sparc64
+ * @ingroup libmath
+ */
+
Index: uspace/lib/nettl/doc/doxygroups.h
===================================================================
--- uspace/lib/nettl/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/nettl/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup libnettl libnettl
+ * @ingroup libs
+ */
Index: uspace/lib/nic/doc/doxygroups.h
===================================================================
--- uspace/lib/nic/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/nic/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup libnic libnic
+ * @ingroup libs
+ */
Index: uspace/lib/posix/doc/doxygroups.h
===================================================================
--- uspace/lib/posix/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/posix/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,4 @@
+/** @addtogroup libposix libposix
+ * @ingroup libs
+ * @brief POSIX emulation library
+ */
Index: uspace/lib/scsi/doc/doxygroups.h
===================================================================
--- uspace/lib/scsi/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/scsi/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup libscsi libscsi
+ * @ingroup libs
+ */
Index: uspace/lib/sif/doc/doxygroups.h
===================================================================
--- uspace/lib/sif/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/sif/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup libsif libsif
+ * @ingroup libs
+ */
Index: uspace/lib/softfloat/doc/doxygroups.h
===================================================================
--- uspace/lib/softfloat/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/softfloat/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,4 @@
+/** @addtogroup softfloat libsoftfloat
+ * @ingroup libs
+ * @brief Software emulation of floating point operations
+ */
Index: uspace/lib/softint/doc/doxygroups.h
===================================================================
--- uspace/lib/softint/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/softint/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,4 @@
+/** @addtogroup softint libsoftint
+ * @ingroup libs
+ * @brief Software emulation of integer operations
+ */
Index: uspace/lib/softrend/doc/doxygroups.h
===================================================================
--- uspace/lib/softrend/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/softrend/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup softrend libsoftrend
+ * @ingroup libs
+ */
Index: uspace/lib/trackmod/doc/doxygroups.h
===================================================================
--- uspace/lib/trackmod/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/trackmod/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup trackmod libtrackmod
+ * @ingroup libs
+ */
Index: uspace/lib/untar/doc/doxygroups.h
===================================================================
--- uspace/lib/untar/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/untar/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup libuntar libuntar
+ * @ingroup libs
+ */
Index: uspace/lib/uri/doc/doxygroups.h
===================================================================
--- uspace/lib/uri/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
+++ uspace/lib/uri/doc/doxygroups.h	(revision 412241029cdceceae7ccb252914ce4d698abd985)
@@ -0,0 +1,3 @@
+/** @addtogroup uri liburi
+ * @ingroup libs
+ */