Index: uspace/srv/fs/tmpfs/tmpfs_ops.c
===================================================================
--- uspace/srv/fs/tmpfs/tmpfs_ops.c	(revision 4f302225f2b25aadcba779f5a36656dd5a66959e)
+++ uspace/srv/fs/tmpfs/tmpfs_ops.c	(revision 46577995860f76c247274a43eb6f67b944f0d3a8)
@@ -64,20 +64,20 @@
 
 /* Forward declarations of static functions. */
-static int tmpfs_match(fs_node_t **, fs_node_t *, const char *);
-static int tmpfs_node_get(fs_node_t **, service_id_t, fs_index_t);
-static int tmpfs_node_open(fs_node_t *);
-static int tmpfs_node_put(fs_node_t *);
-static int tmpfs_create_node(fs_node_t **, service_id_t, int);
-static int tmpfs_destroy_node(fs_node_t *);
-static int tmpfs_link_node(fs_node_t *, fs_node_t *, const char *);
-static int tmpfs_unlink_node(fs_node_t *, fs_node_t *, const char *);
+static errno_t tmpfs_match(fs_node_t **, fs_node_t *, const char *);
+static errno_t tmpfs_node_get(fs_node_t **, service_id_t, fs_index_t);
+static errno_t tmpfs_node_open(fs_node_t *);
+static errno_t tmpfs_node_put(fs_node_t *);
+static errno_t tmpfs_create_node(fs_node_t **, service_id_t, int);
+static errno_t tmpfs_destroy_node(fs_node_t *);
+static errno_t tmpfs_link_node(fs_node_t *, fs_node_t *, const char *);
+static errno_t tmpfs_unlink_node(fs_node_t *, fs_node_t *, const char *);
 
 /* Implementation of helper functions. */
-static int tmpfs_root_get(fs_node_t **rfn, service_id_t service_id)
+static errno_t tmpfs_root_get(fs_node_t **rfn, service_id_t service_id)
 {
 	return tmpfs_node_get(rfn, service_id, TMPFS_SOME_ROOT); 
 }
 
-static int tmpfs_has_children(bool *has_children, fs_node_t *fn)
+static errno_t tmpfs_has_children(bool *has_children, fs_node_t *fn)
 {
 	*has_children = !list_empty(&TMPFS_NODE(fn)->cs_list);
@@ -227,5 +227,5 @@
 {
 	fs_node_t *rfn;
-	int rc;
+	errno_t rc;
 	
 	rc = tmpfs_create_node(&rfn, service_id, L_DIRECTORY);
@@ -252,5 +252,5 @@
 }
 
-int tmpfs_match(fs_node_t **rfn, fs_node_t *pfn, const char *component)
+errno_t tmpfs_match(fs_node_t **rfn, fs_node_t *pfn, const char *component)
 {
 	tmpfs_node_t *parentp = TMPFS_NODE(pfn);
@@ -267,5 +267,5 @@
 }
 
-int tmpfs_node_get(fs_node_t **rfn, service_id_t service_id, fs_index_t index)
+errno_t tmpfs_node_get(fs_node_t **rfn, service_id_t service_id, fs_index_t index)
 {
 	node_key_t key = {
@@ -286,5 +286,5 @@
 }
 
-int tmpfs_node_open(fs_node_t *fn)
+errno_t tmpfs_node_open(fs_node_t *fn)
 {
 	/* nothing to do */
@@ -292,5 +292,5 @@
 }
 
-int tmpfs_node_put(fs_node_t *fn)
+errno_t tmpfs_node_put(fs_node_t *fn)
 {
 	/* nothing to do */
@@ -298,8 +298,8 @@
 }
 
-int tmpfs_create_node(fs_node_t **rfn, service_id_t service_id, int lflag)
+errno_t tmpfs_create_node(fs_node_t **rfn, service_id_t service_id, int lflag)
 {
 	fs_node_t *rootfn;
-	int rc;
+	errno_t rc;
 
 	assert((lflag & L_FILE) ^ (lflag & L_DIRECTORY));
@@ -335,5 +335,5 @@
 }
 
-int tmpfs_destroy_node(fs_node_t *fn)
+errno_t tmpfs_destroy_node(fs_node_t *fn)
 {
 	tmpfs_node_t *nodep = TMPFS_NODE(fn);
@@ -351,5 +351,5 @@
 }
 
-int tmpfs_link_node(fs_node_t *pfn, fs_node_t *cfn, const char *nm)
+errno_t tmpfs_link_node(fs_node_t *pfn, fs_node_t *cfn, const char *nm)
 {
 	tmpfs_node_t *parentp = TMPFS_NODE(pfn);
@@ -386,5 +386,5 @@
 }
 
-int tmpfs_unlink_node(fs_node_t *pfn, fs_node_t *cfn, const char *nm)
+errno_t tmpfs_unlink_node(fs_node_t *pfn, fs_node_t *cfn, const char *nm)
 {
 	tmpfs_node_t *parentp = TMPFS_NODE(pfn);
@@ -421,15 +421,15 @@
  */
 
-static int tmpfs_fsprobe(service_id_t service_id, vfs_fs_probe_info_t *info)
+static errno_t tmpfs_fsprobe(service_id_t service_id, vfs_fs_probe_info_t *info)
 {
 	return ENOTSUP;
 }
 
-static int
+static errno_t
 tmpfs_mounted(service_id_t service_id, const char *opts, fs_index_t *index,
     aoff64_t *size)
 {
 	fs_node_t *rootfn;
-	int rc;
+	errno_t rc;
 	
 	/* Check if this device is not already mounted. */
@@ -458,5 +458,5 @@
 }
 
-static int tmpfs_unmounted(service_id_t service_id)
+static errno_t tmpfs_unmounted(service_id_t service_id)
 {
 	tmpfs_instance_done(service_id);
@@ -464,5 +464,5 @@
 }
 
-static int tmpfs_read(service_id_t service_id, fs_index_t index, aoff64_t pos,
+static errno_t tmpfs_read(service_id_t service_id, fs_index_t index, aoff64_t pos,
     size_t *rbytes)
 {
@@ -525,5 +525,5 @@
 }
 
-static int
+static errno_t
 tmpfs_write(service_id_t service_id, fs_index_t index, aoff64_t pos,
     size_t *wbytes, aoff64_t *nsize)
@@ -589,5 +589,5 @@
 }
 
-static int tmpfs_truncate(service_id_t service_id, fs_index_t index,
+static errno_t tmpfs_truncate(service_id_t service_id, fs_index_t index,
     aoff64_t size)
 {
@@ -626,10 +626,10 @@
 }
 
-static int tmpfs_close(service_id_t service_id, fs_index_t index)
-{
-	return EOK;
-}
-
-static int tmpfs_destroy(service_id_t service_id, fs_index_t index)
+static errno_t tmpfs_close(service_id_t service_id, fs_index_t index)
+{
+	return EOK;
+}
+
+static errno_t tmpfs_destroy(service_id_t service_id, fs_index_t index)
 {
 	node_key_t key = {
@@ -646,5 +646,5 @@
 }
 
-static int tmpfs_sync(service_id_t service_id, fs_index_t index)
+static errno_t tmpfs_sync(service_id_t service_id, fs_index_t index)
 {
 	/*